/* ⮬ 䠩 ந室 ࠡ⪠  */
#include <io8252.h>
#include "keyb.h"
#include "time.h"
#include "lcd.h"
#include "eeprom.h"
#include "chast.h"

#define FreqProc 12000000 /* */

#define START P3.7


code char Mes[] = {0,31,28,31,30,31,30,31,31,30,0,0,0,0,0,0,31,30,31};
code char Chas[] = {16,20,30,24,20,24,28};
code char TMax[] = { 8, 5, 5, 3, 2, 2, 2};
/*                   1  2  3  4  5  6  7 */
code char Autor[] = {" ᪠ ."};
extern data unsigned long Chastota, Prom;
extern data unsigned char rgm, IE18, Timer2, rgmAlarm;
extern data unsigned char i1, i2, T2Int, T2Max;
extern data unsigned long Zn;
extern data unsigned char Key[16];
static data unsigned char Dat, i_main;

extern data union uLONGS
{
    struct
    {
        unsigned char b0;
        unsigned char b1;
        unsigned char b2;
        unsigned char b3;
    } BYTES;
    unsigned long LONG;
} CH;

void Zvuk (void)
{
    i2 = 20;
    while (--i2)
    {
        P1.3 ^= 1;
        i1 = 69;
        while (--i1);
    }
    P1.3 = 1;
}

void Keyb(void)
{
    if (Kla1 || Kla2)
    {
        Zvuk();
        if (fAlarm)
        {
            fAlarm = 0;
            TR1 = 0;
            ET1 = 0;
            IP = 0x2f;
            P1.2 = 1;
            Kla1 = 0;
            Kla2 = 0;
            return;
        }
        if (Kla1.0)  /* 0 */
        {
            Kla1.0 = 0;
            if (Key[15]);
            else if (rgm == Gen)
            {
                Zn = Zn * 10;
                fGen = 1;
            }
            else if (rgm == Alarm)
            {
                rgmAlarm++;
                if (rgmAlarm > rgmAlarmMax) rgmAlarm = 0;
            }
        }
        if (Kla1.1)  /* 1 */
        {
            Kla1.1 = 0;
            if (rgm == Gen)
            {
                Zn = (Zn * 10) + 1;
                fGen = 1;
            }
            else if (rgm == Alarm) /*⠭ ᮢ 㤨쭨*/
            {
                i_main = Rd8583(0x20+(rgmAlarm*3));
                if (Key[4])
                {
                    i_main++;
                    if (i_main > 24) i_main = 0;
                }
                if (Key[8])
                {
                    i_main--;
                    if (i_main > 24) i_main = 24;
                }
                WrD8583 (0x20+(rgmAlarm*3),i_main);
            }
            else if (rgm == Time) /*⠭ ᮢ */
            {
                fEO = 1;
                Dat = Rd8583(hours);
                i_main = ((Dat / 16) * 10) + (Dat & 0x0f);
                if (Key[4])
                {
                    i_main++;
                    if (i_main > 23) i_main = 0;
                } else 
                if (Key[8])
                {
                    i_main--;
                    if (i_main > 23) i_main = 23;
                } else P3.4 ^= 1;
                WrD8583 (hours,((i_main / 10) * 16) + (i_main % 10));
            }
        }
        if (Kla1.5)  /* 2 */
        {
            Kla1.5 = 0;
            if (rgm == Gen)
            {
                Zn = (Zn * 10) + 2;
                fGen = 1;
            }
            else if (rgm == Alarm) /*⠭  㤨쭨*/
            {
                i_main = Rd8583(0x21+(rgmAlarm*3));
                if (Key[4])
                {
                    i_main++;
                    if (i_main > 59) i_main = 0;
                }
                if (Key[8])
                {
                    i_main--;
                    if (i_main > 59) i_main = 59;
                }
                WrD8583 (0x21+(rgmAlarm*3),i_main);
            }
            else if (rgm == Time) /*⠭ */
            {
                fEO = 1;
                Dat = Rd8583(minutes);
                i_main = ((Dat / 16) * 10) + (Dat & 0x0f);
                if (Key[4])
                {
                    i_main++;
                    if (i_main > 59) i_main = 0;
                } else
                if (Key[8])
                {
                    i_main--;
                    if (i_main > 59) i_main = 59;
                } else P3.4 ^= 1;
                WrD8583 (minutes,((i_main / 10) * 16) + (i_main % 10));
            }
        }
        if (Kla2.1)  /* 3 */
        {
            Kla2.1 = 0;
            if (rgm == Gen)
            {
                Zn = (Zn * 10) + 3;
                fGen = 1;
            }
            else if (rgm == Alarm)
            {
                WrD8583 (0x22+(rgmAlarm*3), (Rd8583(0x22+(rgmAlarm*3)) ^ 0x02));
            }
            else if (rgm == Time)
            {
                if (Key[4] || Key[8])
                {
                    fEO = 0;
                    WrD8583 (seconds,0x00);
                } else P3.4 ^= 1;
            }
        }
        if (Kla1.2)  /* 4 */
        {
            Kla1.2 = 0;
            if (rgm == Gen)
            {
                Zn = (Zn * 10) + 4;
                fGen = 1;
            }
            else if (rgm == Alarm)
            {
                WrD8583 (0x22+(rgmAlarm*3), (Rd8583(0x22+(rgmAlarm*3)) ^ 0x04));
            }
            else if (rgm == Time)
            {
                fEO = 1;
                Dat = Rd8583(day);
                if (Key[4])
                {
                    Dat++;
                    if (Dat > 7) Dat = 1;
                } else
                if (Key[8])
                {
                    Dat--;
                    if (Dat == 0) Dat = 7;
                } else P3.4 ^= 1;
                WrD8583 (day,Dat);
            }
        }
        if (Kla1.6)  /* 5 */
        {
            Kla1.6 = 0;
            if (rgm == Gen)
            {
                Zn = (Zn * 10) + 5;
                fGen = 1;
            }
            else if (rgm == Alarm)
            {
                WrD8583 (0x22+(rgmAlarm*3), (Rd8583(0x22+(rgmAlarm*3)) ^ 0x08));
            }
            else if (rgm == Time)
            {
                fEO = 1;
                Dat = Rd8583(date);
                i1 = Rd8583(month);
                i2 = Rd8583(year);
                i_main = ((Dat / 16) * 10) + (Dat & 0x0f);
                if (Key[4])
                {
                    i_main++;
                    if ((i1 == 2) && ((i2 % 4) == 0)) Dat = 29;
                    else Dat = Mes[i1];
                    if (i_main > Dat) i_main = 1;
                } else
                if (Key[8])
                {
                    i_main--;
                    if ((i1 == 2) && ((i2 % 4) == 0)) Dat = 29;
                    else Dat = Mes[i1];
                    if (i_main == 0) i_main = Dat;
                } else P3.4 ^= 1;
                WrD8583 (date,((i_main / 10) * 16) + (i_main % 10));
            }
        }
        if (Kla2.2)  /* 6 */
        {
            Kla2.2 = 0;
            if (rgm == Gen)
            {
                Zn = (Zn * 10) + 6;
                fGen = 1;
            }
            else if (rgm == Alarm)
            {
                WrD8583 (0x22+(rgmAlarm*3), (Rd8583(0x22+(rgmAlarm*3)) ^ 0x10));
            }
            else if (rgm == Time)
            {
                fEO = 1;
                Dat = Rd8583(month);
                i_main = ((Dat / 16) * 10) + (Dat & 0x0f);
                if (Key[4])
                {
                    i_main++;
                    if (i_main > 12) i_main = 1;
                } else
                if (Key[8])
                {
                    i_main--;
                    if (i_main == 0) i_main = 12;
                } else P3.4 ^= 1;
                WrD8583 (month,((i_main / 10) * 16) + (i_main % 10));
            }
        }
        if (Kla1.3)  /* 7 */
        {
            Kla1.3 = 0;
            if (rgm == Gen)
            {
                Zn = (Zn * 10) + 7;
                fGen = 1;
            }
            else if (rgm == Alarm)
            {
                WrD8583 (0x22+(rgmAlarm*3), (Rd8583(0x22+(rgmAlarm*3)) ^ 0x20));
            }
            else if (rgm == Time)
            {
                fEO = 1;
                Dat = Rd8583(year);
                i_main = ((Dat / 16) * 10) + (Dat & 0x0f);
                if (Key[4])
                {
                    i_main++;
                    if (i_main > 99) i_main = 0;
                } else
                if (Key[8])
                {
                    i_main--;
                    if (i_main > 99) i_main = 99;
                } else P3.4 ^= 1;
                WrD8583 (year,((i_main / 10) * 16) + (i_main % 10));
            }
        }
        if (Kla1.7)  /* 8 */
        {
            Kla1.7 = 0;
            if (rgm == Gen)
            {
                Zn = (Zn * 10) + 8;
                fGen = 1;
            }
            else if (rgm == Alarm)
            {
                WrD8583 (0x22+(rgmAlarm*3), (Rd8583(0x22+(rgmAlarm*3)) ^ 0x40));
            }
            else if (rgm == Time) P3.4 ^= 1;
        }
        if (Kla2.3)  /* 9 */
        {
            Kla2.3 = 0;
            if (rgm == Gen)
            {
                Zn = (Zn * 10) + 9;
                fGen = 1;
            }
            else if (rgm == Alarm)
            {
                WrD8583 (0x22+(rgmAlarm*3), (Rd8583(0x22+(rgmAlarm*3)) ^ 0x80));
            }
            else if (rgm == Time) P3.4 ^= 1;
        }
        if (Kla1.4)  /* B */
        {
            Kla1.4 = 0;
            if (rgm == Gen)
            {
                Zn /= 10;
                fGen = 1;
            }
            else
            if (rgm == Sum)
            {
                if (fStpSum == 1)
                {
                    START = 0;
                    TR1 = 0;
                    fStpSum = 0;
                    fEO = 1;
                    wrlcd (0x01,' ');
                }
                else
                {
                    TR1 = 1;
                    START = 1;
                    fStpSum = 1;
                    wrlcd (0x01,'>');
                }
            } else
            if (rgm == Frq) FreqRgm = 0;
        }
        if (fGen)
        {
            fEO = 1;
            fGen = 0;
            if (Zn > 3000000) Zn %= 10000000;
            if (Zn > 3000000) Zn %= 1000000;
        }
        if (Kla2.0)  /* R */
        {
            Kla2.0 = 0;
            if (rgm == Gen)
            {
                CH.LONG = Zn;
                eepromWR (0x10,CH.BYTES.b0);
                eepromWR (0x11,CH.BYTES.b1);
                eepromWR (0x12,CH.BYTES.b2);
                eepromWR (0x13,CH.BYTES.b3);
                Gener();
            }
            else
            if (rgm == Sum)
            {
                START = 0;
                TR1 = 0;
                IE18 = P2;
                TH1 = 0;
                TL1 = 0;
                CH.BYTES.b0 = 0;
                if (fStpSum == 1)
                {
                    TR1 = 1;
                    START = 1;
                }
            } else
            if (rgm == Frq) FreqRgm = 1;
        }
        if (Kla2.7)
        {
            Kla2.7 = 0;
            fIzmRgm = 1;
            if (!fPresTime) rgm = Frq;
            else
            {
                if (!Key[12]) rgm = Frq;
                else rgm = Sum;
            }
        }
        if (Kla2.6)
        {
            Kla2.6 = 0;
            fIzmRgm = 1;
            if (!fPresTime) rgm = Per;
            else
            {
                if (!Key[12]) rgm = Per;
                else rgm = Time;
            }
        }
        if (Kla2.5)  /* P */
        {
            Kla2.5 = 0;
            fIzmRgm = 1;
            if (!fPresTime) rgm = Gen;
            else
            {
                if (!Key[12]) rgm = Gen;
                else rgm = Alarm;
            }
        }
        if (Kla2.4)  /* G */
        {
            Kla2.4 = 0;
            if (!fPresTime)
            {
                rgm = Sum;
                fIzmRgm = 1;
            }
        }
        if (rgm == Alarm) fEO = 1;
    }
    if (fIzmRgm == 1) /*⠭  ०*/
    {
        fIzmRgm = 0;
        eepromWR (0x00, rgm);
        fEO = 1;
        if (rgm == Frq) /*० ७ */
        {
            EX0 = 0;
            EX1 = 0;
            ET1 = 1;
            TR1 = 1;
            START = 0;
            IE18 = P2;
            fIzmCh = 0;
            TMOD = 0x51;
            Chastota = P2;
            Print (0x0d," Hz");
            wrlcd (0x00, 'F');
            wrlcd (0x01, '>');
            wrlcd (0x41, ' ');
        } else
        if (rgm == Per) /*० ७ ਮ*/
        {
            EX0 = 0;
            TMOD = 0x91;
            EX1 = 1;
            ET1 = 1;
            TR1 = 1;
            START = 1;
            Timer2 = 45;
            wrlcd (0x40, 'P');
            wrlcd (0x41, '>');
            wrlcd (0x01, ' ');
            Print (0x4d," uS");
        } else
        if (rgm == Sum) /*०  室 ᮢ*/
        {
            EX0 = 0;
            TR1 = 0;
            ET1 = 1;
            START = 0;
            IE18 = P2;
            TH1 = 0;
            TL1 = 0;
            CH.BYTES.b0 = 0;
            TMOD = 0x51;
            EX1 = 0;
            TR1 = 1;
            START = 1;
            fStpSum = 1;
            wrlcd (0x00,'S');
            wrlcd (0x01,'>');
            Print (0x0d,"   ");
            Print (0x40,"                ");
        } else
        if (rgm == Gen) /*०   */
        {
            EX0 = 0;
            START = 0;
            fIzmCh = 0;
            TMOD = 0x51;
            EX1 = 0;
            wrlcd (0x00, 'G');
            wrlcd (0x01, '>');
            Print (0x0d,"   ");
            wrlcd (0x40, 'F');
            wrlcd (0x41, ' ');
            Print (0x4d," Hz");
        } else
        if (rgm == Time) /*० */
        {
            EX0 = 1;
            EX1 = 0;
            TR1 = 0;
        } else
        if (rgm == Alarm) /*० 㤨쭨*/
        {
            EX0 = 0;
            EX1 = 0;
            TR1 = 0;
            Print (0x00,"㤨쭨  ");
        }
    }
}

void Gener(void)
{
    if (Zn == 0)
    {
        T2CON &= 0x0b; /*⠭ ⠩ 2*/
        T2MOD = 0; /*뢮 1.0 ⪫  室 ⠩*/
    }
    else
    {
        if (Zn < 46)
        {
            ET2 = 1;   /*뢠  ⠩ ࠧ*/
            T2MOD = 0; /*뢮 1.0 ⪫  室 ⠩*/
            if (Zn < 8)
            {
                Dat = Chas[Zn - 1];
                T2Max = TMax[Zn - 1] - 1;
                fChas = 0;
            }
            else
            {
                Dat = Zn << 1;
                fChas = 1;
            }
            Prom = Dat;
            RCAP2H = (65536 - (FreqProc / 12 / Prom)) >> 8;
            RCAP2L = (65536 - (FreqProc / 12 / Prom)) & 0xff;
        }
        else
        {
            ET2 = 0;     /*뢠  ⠩ */
            T2MOD = 0x02; /*뢮 1.0   室 ⠩*/
            RCAP2H = (65536 - (FreqProc / 4 / Zn)) >> 8;
            RCAP2L = (65536 - (FreqProc / 4 / Zn)) & 0xff;
        }
        T2CON |= 0x04; /* ⠩ 2*/
    }
}
