#include <io8252.h>
#include "init.h"

#define FreqProc 12000000 /* */
#define FInt 50 /* 뢠*/
#define FClock 1000000 /* 뢠*/
#define T0H (65536 - (FreqProc / 12 / FInt)) >> 8
#define T0L (65536 - (FreqProc / 12 / FInt)) & 0xff
#define R2H (65536 - (FreqProc / 4 / FClock)) >> 8
#define R2L (65536 - (FreqProc / 4 / FClock)) & 0xff
#define SpeedCom(Speed) (256 - (char)((double)FreqProc / 12.0 / 16.0 / ((double)Speed) + 0.5))
#define Freq(freq) (65535 - (unsigned int)((double)FreqProc / 12.0 / ((int)freq))

void InitCom ()
{
    SCON = 0x52;    
    PCON = 0x80;    
    TMOD = 0x51;    
    TCON = 0x55;    
    T2CON = 0x00;
    IP = 0x2f;
    IE = 0x82;
    WMCON = 0xeb;   /*11100011*/
}


